

//+------------------------------------------------------------------+
//|                      OM NAMAH SIVAY                              |
//|        OM NAMAH SIVAY              OM NAMAH SIVAY                |
//|    OM NAMAH SIVAY    OM NAMAH SIVAY    OM NAMAH SIVAY            |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, OM Corp."
#property link "http://www.jatinpruthvi.co.cc"

// Include  our class patel
#include "Jatin_Pair.mqh"
#include <Trade\Trade.mqh>
#include <Trade\PositionInfo.mqh> //include the library for obtaining information on
//--- input parameters
input int ADX_Period = 14;    // ADX Period
input int MA_Period = 10;     // Moving Average Period
input int EA_Magic = 24290;      // EA Magic Number
input double Adx_Min = 22.0;  // Minimum ADX Value
input double Lot = 0.01;          // Lots to Trade
input int Margin_Chk = 1;        // Check Margin before placing trade(0=No, 1=Yes)
input double Trd_percent = 15.0; // Percentage of Free Margin To use for Trading
input double AccountTP = 0.6;
input double AccountSL = -20;
input ENUM_TIMEFRAMES period = PERIOD_CURRENT;

//--- other parameters

//+------------------------------------------------------------------+
//| Expert Global Variable                                           |
//+------------------------------------------------------------------+

MqlTradeRequest trequest; // MQL5 trade request structure to be used for sending our trade requests
MqlTradeResult tresult; // MQL5 trade result structure to be used to get our trade results



ENUM_ORDER_TYPE BBS[] = { ORDER_TYPE_BUY, ORDER_TYPE_BUY, ORDER_TYPE_SELL };  // BUY BUY SELL
ENUM_ORDER_TYPE SSB[] = { ORDER_TYPE_SELL, ORDER_TYPE_SELL, ORDER_TYPE_BUY }; // SELL SELL BUY
// 1 for bbs , 2 for ssb
CPositionInfo m_Position; // structure for obtaining information of positions

MyPair CmyPair[10];
int pairRating[10];
int pairSize = 0;
string SYMBOLS_OF_PAIR[] = {
	"EURCHF;CHFJPY;EURJPY", "GBPCHF;CHFJPY;GBPJPY", "USDCHF;CHFJPY;USDJPY", "EURGBP;GBPCHF;EURCHF",
	"EURUSD;USDCHF;EURCHF", "EURGBP;GBPJPY;EURJPY", "EURGBP;GBPUSD;EURUSD", "EURUSD;USDJPY;EURJPY",
	"GBPUSD;USDCHF;GBPCHF", "GBPUSD;USDJPY;GBPJPY"
};
string BEST_PAIR = NULL;
int BBSorSSB = -1;
int Winner_Pair_Index = -1;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
	pairSize = ArraySize(SYMBOLS_OF_PAIR);
	if(AccountSL > 0) AccountSL = AccountSL * -1;
	//--- Set event generation frequency
	EventSetTimer(1); // 1 second

	//--- run Initialize function void init(string reqPair,int ADX_Periods, int MA_Periods , int Adx_Mins)
	for (int i = 0; i < pairSize; i++) {
		CmyPair[i].init(SYMBOLS_OF_PAIR[i], period, ADX_Period, MA_Period, Adx_Min);
	}

	return (0);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
	ZeroMemory(trequest);
	ZeroMemory(tresult);
	//--- Termination of event generation
	EventKillTimer();
	//--- Run UnIntilialize function
	for (int i = 0; i < pairSize; i++) {
		CmyPair[i].doUnunit();
	}
}

int DayOfWeek()
{
	MqlDateTime tm;
	TimeCurrent(tm);
	return (tm.day_of_week);
}

double calculateProfit()
{
	return AccountInfoDouble(ACCOUNT_PROFIT);
}

void closeAllOrder()
{
	CTrade trade;
	for (int i = PositionsTotal() - 1; i >= 0; i--)
	{
		{
			if (!trade.PositionClose(PositionGetSymbol(i)))
			{
				Print(PositionGetSymbol(i), "PositionClose() method failed. Return code=", trade.ResultRetcode(), ". Code description: ", trade.ResultRetcodeDescription());//--- failure message
			}
		}
	}
}


int countTotalOpenOrder()
{
	int total = PositionsTotal();
	int count = 0;
	for (int cnt = 0; cnt <= total - 1; cnt++)
	{
		if (PositionSelect(Symbol()))
		{
			if (PositionGetInteger(POSITION_MAGIC) == EA_Magic)
			{
				count++;
			}
		}
	}

	return(count);
}

void processPairSignal(){
	for (int i = 0; i < pairSize; i++){
		CmyPair[i].processSignal();
	}
}
int findMaxRating(){
	int max = 0;
	for (int i = 0; i<pairSize; i++){
		if (pairRating[i] >max){
			max = pairRating[i];
		}
	}
	return max;
}
void findMaxRatePair(int max){
	string str = "";
	string ratingArray[];
	BEST_PAIR = NULL;
	BBSorSSB = -1;
	Winner_Pair_Index = -1;
	if (max <= 0) return;
	for (int i = 0; i < pairSize; i++){
		if (pairRating[i] == max){
			str = str + i + ";";
		}
	}
	str = StringSubstr(str, 0, StringLen(str) - 1);
	int ratingArray_size = StringSplit(str, StringGetCharacter(";", 0), ratingArray);
	//double spreadArray[ratingArray_size];
	double spreadArray[10];
	ArrayInitialize(spreadArray,999999);
	//ArrayInitialize(spreadArray,-1);
	for (int j = 0; j < ratingArray_size; j++){
		spreadArray[j] = CmyPair[(int)ratingArray[j]].getTotalSpread();
	}
	//find lowest spread
	int min = 99999;
	int index = -1;
		for (int j = 0; j < ratingArray_size; j++){
			if (spreadArray[j] < min){
				min = spreadArray[j];
				index = j;
			}
		}

	if (index != -1){
		Winner_Pair_Index = ratingArray[index];
		BEST_PAIR = CmyPair[Winner_Pair_Index].getPair();
		BBSorSSB = CmyPair[Winner_Pair_Index].getBBSorSSB();
		Print("winner Pair" + BEST_PAIR);
		Print("MINIMUM PARI" + min);
	}
	else{
		Print("Bug in EA");
	}
}
void findBestPair(){
	int maxRating = 0;
	for (int i = 0; i < pairSize; i++){
		pairRating[i] = CmyPair[i].getRating();
	}
	maxRating = findMaxRating();
	findMaxRatePair(maxRating);
}

//-===================== The OnTimer function
//======================================================
void OnTimer()
{
	int dayOfWeek = DayOfWeek();
	if (dayOfWeek == 0 || dayOfWeek == 6) {
		Sleep(900000); // 15 min
		return;
	}
	
	if (countTotalOpenOrder() > 0) // FUTURE DEVELOPMENT : ALL ORDERS ARE OPEN OR NOT
	{
		double acProfit = calculateProfit();
	
	if (acProfit < AccountSL){
		closeAllOrder();
	}else if (acProfit > AccountTP) {
		string beforeSignal = BEST_PAIR;
		processPairSignal();
		findBestPair();
		if (beforeSignal == BEST_PAIR && BBSorSSB != -1){
			return;
		}
		closeAllOrder();
	}
		return;
	}
	if (Margin_Chk == 1 && !MarginOK()){
		return;
	}

	processPairSignal();
	findBestPair();

	if (BBSorSSB == -1 || BEST_PAIR == NULL || Winner_Pair_Index == -1)
		return;

	if (BBSorSSB == 1) {
		placeBBS();
	}
	else if (BBSorSSB == 2) {
		placeSSB();
	}
}

void placeBBS()
{
	for (int i = 0; i < 3; i++) {
		openBuySell(BBS[i], CmyPair[Winner_Pair_Index].EA_Symbols_Array[i]);

	}
}
void placeSSB()
{
	for (int i = 0; i < 3; i++) {
		openBuySell(SSB[i], CmyPair[Winner_Pair_Index].EA_Symbols_Array[i]);
	}
}

bool openBuySell(ENUM_ORDER_TYPE otype, string symbol)
{

	bool result = false;
	double oprice = 0, stl = 0, tkp = 0, ask = 0, bid = 0;
	MqlTick latest_price;
	bool bidask = false;
	if (SymbolInfoTick(symbol, latest_price)) {
		bidask = true;
	}
	int digits = (int)SymbolInfoInteger(symbol, SYMBOL_DIGITS); // number of decimal places
	double nPoint = SymbolInfoDouble(symbol, SYMBOL_POINT);
	if (otype == ORDER_TYPE_BUY) {
		ask = bidask ? latest_price.ask : SymbolInfoDouble(symbol, SYMBOL_ASK);
		oprice = NormalizeDouble(ask, digits); // current Ask price
		// stl = NormalizeDouble(ask - STP * nPoint, digits); // Stop Loss
		// tkp = NormalizeDouble(ask + TKP * nPoint, digits); // Take profit
	}
	else if (otype == ORDER_TYPE_SELL) {
		bid = bidask ? latest_price.bid : SymbolInfoDouble(symbol, SYMBOL_BID);
		oprice = NormalizeDouble(bid, digits); // Current Bid price
		// stl = NormalizeDouble(bid + STP * nPoint, digits); // Stop Loss
		// tkp = NormalizeDouble(bid - TKP * nPoint, digits); // Take Profit
	}
	else {
		Print("Invalid Order Type");
		return result;
	}

	trequest.action = TRADE_ACTION_DEAL;
	trequest.type = otype;
	trequest.volume = Lot;
	trequest.price = oprice;
	trequest.sl = 0;
	trequest.tp = 0;
	trequest.deviation = 1000;
	trequest.magic = EA_Magic;
	trequest.symbol = symbol;
	trequest.type_filling = ORDER_FILLING_FOK;

	OrderSend(trequest, tresult);
	if (tresult.retcode == 10009 || tresult.retcode == 10008) // Request successfully completed
	{
		result = true;
		Print("A Buy order has been successfully placed with Ticket#:", tresult.order, "!!");
	}
	else {
		result = false;
		Print("The Buy order request could not be completed#:", GetLastError(), "!!");
		// Errormsg = "The Buy order request could not be completed";
		// Errcode = GetLastError();
		// showError(Errormsg, Errcode);
	}
	return result;
}

//+------------------------------------------------------------------+
//| MARGINOK FUNCTION                                                |
//| *No input parameters                                             |
//| *Uses the Class data members to check margin required to place   |
//| a trade with the lot size is ok                                  |
//| *Returns TRUE on success and FALSE on failure                    |
//+------------------------------------------------------------------+

bool MarginOK()
{
	double one_lot_price; // Margin required for one lot
	double act_f_mag = AccountInfoDouble(ACCOUNT_FREEMARGIN); // Account free margin
	long levrage = AccountInfoInteger(ACCOUNT_LEVERAGE); // Leverage for this account
	double contract_size = SymbolInfoDouble("GBPUSD", SYMBOL_TRADE_CONTRACT_SIZE); // Total units for one lot
	string base_currency = SymbolInfoString("GBPUSD", SYMBOL_CURRENCY_BASE); // Base currency for currency pair
	//
	if (base_currency == "USD") {
		one_lot_price = contract_size / levrage;
	}
	else {
		double bprice = SymbolInfoDouble("GBPUSD", SYMBOL_BID);
		one_lot_price = bprice * contract_size / levrage;
	}
	// Check if margin required is okay based on setting
	if (MathFloor(Lot * one_lot_price * 3) > MathFloor(act_f_mag * Trd_percent)) {
		return (false);
	}
	else {
		return (true);
	}
}

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
/*
void OnTick()
{
}

*/

//+------------------------------------------------------------------+

